<?php
/*
Plugin Name:Content Replace Yuzumaru
Plugin URI:http://yuzumaru.info
Description:プラグインの入っている replace_set.cgi に 置換文字列変換文字列を記載
Version:2.2
Author:CamCam custom yuzumaru
Author URI:http://yuzumaru.info
*/

remove_filter('the_content','wpautop');
add_filter('the_content','contentreplace');

function contentreplace($content) {
	$plugin_mydir = WP_PLUGIN_DIR.'/'.$plugin_dir;
	$plugin_myfil = $plugin_mydir."ContentrePlace/replace_set.cgi";
	
	$array_s = array();
	$array_r = array();
	// FILE
	/*
	$tfp=fopen($plugin_myfil,"r");
	if($tfp){
		while(!feof($tfp)){
			$line = fgets($tfp);
			$line = str_replace(array("\r\n", "\r", "\n"), '', $line);
			if(     mb_substr($line,0,2)=="/S"){
				$flag = "S";
				$buff="";
			}elseif(mb_substr($line,0,2)=="/R"){
				$flag = "R";
				$buff="";
			}elseif(mb_substr($line,0,2)=="/E"){
				if($flag == "S"){
					$array_s[]=$buff;
				}elseif($flag=="R"){
					$array_r[]=$buff;
				}
				$buff="";
			}elseif(mb_substr($line,0,1)=="#"){
				
			}else{
				$buff.=$line;
			}
		}
		fclose($tfp);
	}
	*/
	// DB
	$new_count = get_option('ContentReplaceYuzu_max');
	if($new_count == "" ){
		$new_count=0;
	}
	for($i=0;$i<$new_count;$i++){
		$target= get_option('ContentReplaceYuzu_target'.$i);
		$repval= get_option('ContentReplaceYuzu_repval'.$i);
		
		$target = str_replace('\&quot;','"',$target);
		$target = str_replace('&quot;','"',$target);
		$target = str_replace('&lt;','<',$target);
		$target = str_replace('&gt;','>',$target);
		
		$repval = str_replace('\&quot;','"',$repval);
		$repval = str_replace('&quot;','"',$repval);
		$repval = str_replace('&lt;','<',$repval);
		$repval = str_replace('&gt;','>',$repval);
		
		$array_s[]=$target;
		$array_r[]=$repval;
	}
	
	$snap="";
	
	$n = 0;
	foreach ($array_s as $value) {
		$rstr = "##".$n."##";
		$snap.= "S:".$n." = $rstr = ".$value."<br />";
		$content = str_replace($value, $rstr, $content); // cross-platform newlines 
		$n++;
	}

	$n = 0;
	foreach ($array_r as $value) {
		$rstr = "##".$n."##";
		$snap.= "R:".$n." = $rstr = ".$value."<br />";
		$content = str_replace($rstr, $value, $content); // cross-platform newlines 
		$n++;
	}

	$snap = "plugin_myfil:$plugin_myfil<br /><br />$snap<br /><br />$xsnap";
	//return $snap.$content; 
	return $content; 
}


function contentreplaceA($content) {
	$plugin_mydir = WP_PLUGIN_DIR.'/'.$plugin_dir;
	$plugin_myfil = $plugin_mydir."ContentrePlace/replace_set.cgi";
	
	$array_s = array();
	$array_r = array();
	
	$snap="";
	
	$tfp=fopen($plugin_myfil,"r");
	if($tfp){
		while(!feof($tfp)){
			$line = fgets($tfp);
			$line = str_replace(array("\r\n", "\r", "\n"), '', $line);
			if(     mb_substr($line,0,2)=="/S"){
				$flag = "S";
				$buff="";
			}elseif(mb_substr($line,0,2)=="/R"){
				$flag = "R";
				$buff="";
			}elseif(mb_substr($line,0,2)=="/E"){
				if($flag == "S"){
					$array_s[]=$buff;
				}elseif($flag=="R"){
					$array_r[]=$buff;
				}
				$buff="";
			}elseif(mb_substr($line,0,1)=="#"){
				
			}else{
				$buff.=$line;
			}
		}
		fclose($tfp);

		$n = 0;
		foreach ($array_s as $value) {
			$rstr = "##".$n."##";
			$snap.= "S:".$n." = $rstr = ".$value."<br />";
			$content = str_replace($value, $rstr, $content); // cross-platform newlines 
			$n++;
		}

$xsnap = $content."<hr />";

		$n = 0;
		foreach ($array_r as $value) {
			$rstr = "##".$n."##";
			$snap.= "R:".$n." = $rstr = ".$value."<br />";
			$content = str_replace($rstr, $value, $content); // cross-platform newlines 
			$n++;
		}
	}

	$snap = "plugin_myfil:$plugin_myfil<br /><br />$snap<br /><br />$xsnap";
	//return $snap.$content; 
	return $content; 
}


// 管理メニューに追加するフック（mt_add_pages で細かいことは説明するからって言ってる）
add_action('admin_menu', 'ContentReplaceYuzu_add_pages');
// 上のフックに対するaction関数（細かいことを説明しているところ）
//------------------------------------------------------------------------------
// 設定画面登録
//------------------------------------------------------------------------------
function ContentReplaceYuzu_add_pages() {
	// 設定メニュー(管理メニュー)下にサブメニューを追加:
	add_options_page(
		'Content Replace Yuzu',		// 1.Pluginの設定画面での見出し
		'Content Replace Yuzu',		// 2.WP設定メニューでの表示名
		8,					// 3.管理者権限(誰が触れるよ。基本８でOK)
		__FILE__,			// 4.WP内でぶつからない名前。面倒なら__FILE__でOK.高度な使い方は後
		'ContentReplaceYuzu_options_page'	// 5.設定モジュール名
	);
	
}
//------------------------------------------------------------------------------
// 設定画面本体群
//------------------------------------------------------------------------------
// mt_options_page() はTest Optionsサブメニューのページコンテンツを表示
function ContentReplaceYuzu_options_page() {
	echo "<h2>コンテンツリプレース YUZU ver 1.60601</h2>";

	//--------------------------------------------------------------------------
	// 準備
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	// put
	//--------------------------------------------------------------------------
	if (isset($_POST['update_option'])) {
		$new_count = $_POST["new_count"];
		$rep_count = 0;
		for($i=0;$i<$new_count;$i++){
			$target = $_POST["target".$i];
			$repval = $_POST["repval".$i];
			
			$target = str_replace('<','&lt;'   ,$target);
			$target = str_replace('>','&gt;'   ,$target);
			$target = str_replace('"','&quot;' ,$target);
			
			$repval = str_replace('<','&lt;'   ,$repval);
			$repval = str_replace('>','&gt;'   ,$repval);
			$repval = str_replace('"','&quot;' ,$repval);
			
			if($target != '' ){
				update_option('ContentReplaceYuzu_target'.$rep_count,$target);
				update_option('ContentReplaceYuzu_repval'.$rep_count,$repval);
				$rep_count++;
			}
		}
		update_option('ContentReplaceYuzu_max',$rep_count);
	}
	//--------------------------------------------------------------------------
	// get & VIEW
	//--------------------------------------------------------------------------
	// 表示
	//--------------------------------------------------------------------------
	echo <<<EOD
	<table style="font-size:12px;">
	<form name="form" method="post" action="">
	<tr>
		<td align="center">No.</td>
		<td align="center">ターゲット文字列</td>
		<td align="center">変換文字列</td>
	</tr>
EOD;
	$new_count = get_option('ContentReplaceYuzu_max');
	if($new_count == "" ){
		$new_count=0;
	}
	for($i=0;$i<$new_count;$i++){
		$tstk[$i]=get_option('ContentReplaceYuzu_target'.$i);
		$rstk[$i]=get_option('ContentReplaceYuzu_repval'.$i);
	}
	for($i=0;$i<$new_count-1;$i++){
		for($j=$i+1;$j<$new_count;$j++){
			if( $tstk[$i] > $tstk[$j] ){
				$w        = $tstk[$i];
				$tstk[$i] = $tstk[$j];
				$tstk[$j] = $w;
				
				$w        = $rstk[$i];
				$rstk[$i] = $rstk[$j];
				$rstk[$j] = $w;
			}
		}
	}
	for($i=0;$i<$new_count;$i++){
		/*
		$target= get_option('ContentReplaceYuzu_target'.$i);
		$repval= get_option('ContentReplaceYuzu_repval'.$i);
		*/
		$target = $tstk[$i];
		$repval = $rstk[$i];
		
		$target = str_replace('\&quot;','&quot;',$target);
		$repval = str_replace('\&quot;','&quot;',$repval);
		
		$j = $i+1;
		echo <<<EOD
	<tr>
		<td>$j</td>
		<td><textarea cols="20" rows="1" name="target$i">$target</textarea></td>
		<td><textarea cols="40" rows="1" name="repval$i">$repval</textarea></td>
	</tr>
EOD;
	}
	echo <<<EOD
	<tr>
		<td>new</td>
		<td><textarea cols="20" rows="3" name="target$new_count"></textarea></td>
		<td><textarea cols="40" rows="3" name="repval$new_count"></textarea></td>
	</tr>
EOD;
	$new_count++;
	//--------------------------------------------------------------------------
	// 表示
	//--------------------------------------------------------------------------
	$plugin_myfil = $plugin_mydir."ContentrePlace/replace_set.cgi";
	echo <<<EOD
	<tr>
		<td colspan="3">
			<input type='hidden' name='new_count' value="$new_count">
			<input type='submit' name='update_option' class='buttonprimary'>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br />
			削除する場合は、ターゲット欄を空白にしてください。<br />
			<br />
			このテーブルに追加するほかに $plugin_myfil に 書き込まれた内容も処理します。
		</td>
	</tr>
	</form>
	</table>

EOD;

}


?>